library(Matrix)
library(tseries)
library(kernlab)
source("http://lu-library.googlecode.com/svn/trunk/evaluation.r")


train_batch <- function(splitid) {
	library(kernlab)
	testidx = which(splits[,splitid]==1)
	trainidx = which(splits[,splitid]==0)
	trmat <- as.kernelMatrix(kernels[trainidx,trainidx])
	tsmat <- as.kernelMatrix(kernels[testidx,trainidx])
	print(splitid)
	
	predictions <-  matrix(0, nrow = length(testidx), ncol = length(event.ids))
	for(eventid in 1:length(event.ids)) {
		trlabels = labels[trainidx, eventid]
		model = ksvm(x=trmat, y=trlabels, type = "C-svc", C = 0.5)
		#trprediction = predict(model, trmat, type = "probabilities")[,which(colnames(trprediction)=="1")]
		thistsmat = as.kernelMatrix(tsmat[,SVindex(model)])
		tsprediction = predict(model, thistsmat, type = "decision")
		#tsprediction = tsprediction[,which(colnames(tsprediction)=="1")]
		predictions[,eventid] = tsprediction
	}
	#testmultilabels = make.multilabel(labels[testidx,])
	return(predictions)
}

event.ids <- paste("E",1:12,sep = "")
kernels = read.matrix("data/dev.matrix")
kernels = kernels * 2	#our tool divides pre-calculated kernel by 2 and here we get it back

idlist = as.character(read.table("data/hollywood.idlist")[,1])
labels = read.matrix("data/hollywood.labels")
splits = as.matrix(read.matrix("data/hollywood.splits"))

#batch train
lu = "hollywood2+batchtrain"

splitid = 1
baseline = train_batch(splitid)
testidx = which(splits[,splitid]==1)
testlabels = labels[testidx,]
aps = evaluate.map(baseline, testlabels)
print(mean(aps))


